import {IoHome, IoPaperPlane} from "react-icons/io5";
import {IoIosAddCircle, IoIosHeart} from "react-icons/io";
import {Link} from "react-router-dom"
import { useState } from "react";
import { actionAuthLogout } from "../../actions";
import { connect } from "react-redux";
import CSearchInput from "./SearchInput";


const LogOutButton = ({onClick})=> {
    return(
        <button className="flex px-4 py-2 text-sm text-center" onClick={() => onClick()}>log out</button>
    )
}
const CLogOut = connect(state => ({children: `logout(${state.auth.payload && state.auth.payload.sub.login || 'anon'})`}),
{onClick: actionAuthLogout})(LogOutButton)

const defaultUserInfo = {
    _id:"61fe9cf2ad55d22f3e2fb226",
    nick: "Nik",
    avatar:'1',
    following:"2"
}
/* const UserItem = ({user:{_id,nick,avatar}}) =>{
    return(
        <div>
            {nick}
        </div>
    )
} */
const UserBlock = ({aboutMe = defaultUserInfo}) => {
    const [isOpen, setIsOpen] = useState(false);
    console.log(aboutMe)
    return(
        <div className="relative inline-block text-left">
                        <button onClick={() => setIsOpen(!isOpen)}>
                            {aboutMe.nick ? aboutMe.nick : "something"}
                        </button>
                    {isOpen && <div className="origin-top-right absolute right-0 mt-2 w-36 rounded-md shadow-lg bg-white ring-1 ring-black ring-opacity-5 focus:outline-none flex justify-center">
                        <div className="py-1 w-full text-center">
                            <div className="text-gray-700   hover:bg-fuchsia-700 hover:rounded-md hover:text-white">
                            <Link to={`/user/${aboutMe._id}`} className="block px-4 py-2 text-sm">
                            Account
                    </Link>
                            </div>
                            <div className="text-gray-700   hover:bg-fuchsia-700 hover:rounded-md hover:text-white">
                            <Link to="/settings" className="block px-4 py-2 text-sm">Settings</Link>
                            </div>
                            <div className="text-gray-700 flex justify-center  hover:bg-fuchsia-700 hover:rounded-md hover:text-white">
                                <CLogOut/>
                            </div>
                        </div>
                        </div>}
                    
                    </div>
    )
}

const CUserBlock = connect(state => ({aboutMe: state.promise?.aboutMe?.payload || []}))(UserBlock)


const Header =  ({}) => {
    return(
        <nav className="flex mx-auto px-4 justify-between p-6 xl:container xls:mx-auto dark:bg-slate-900 dark:text-white">
            {/* left */}
            <div className="flex items-center space-x-2 w-1/4">
                <div>
                    <a>
                       <img src={'/src/img/logo.svg'} alt="logo"/> 
                    </a>
                </div>
            </div>
            {/* middle */}
            <div className="w-1/2 sm:w-1/2  md:w-1/5 lg:w-1/4 xl:w-1/3">
               <CSearchInput/>
            </div>
            {/* right */}
            <div className="flex justify-between  pl-2 w-2/5 items-center sm:w-1/2 sm:text-xs md:text-sm md:flex md:justify-between md:w-1/3 ">
                <div  className="group">
                     <div className="group-hover:bg-slate-800 group-hover:text-white group-hover:rounded-full" >
                    <Link to="/"><IoHome/></Link>
                    </div>
                </div>
                <div className="group">
                    <div className="group-hover:bg-slate-800 group-hover:text-white group-hover:rounded-full">
                    <Link to="/direct"><IoPaperPlane/></Link>
                    </div>
                </div>
                <div className="group">
                    <div className="group-hover:bg-slate-800 group-hover:text-white group-hover:rounded-full">
                    <Link to="/"><IoIosAddCircle/></Link>
                    </div>
                </div>
                <div className="group">
                    <div className="group-hover:bg-slate-800 group-hover:text-white group-hover:rounded-full">
                    <Link to="/collections"><IoIosHeart/></Link>
                    </div>
                </div>
                <div>
                    <CUserBlock/>
        
                </div>
            </div>
        </nav>
    )
}


export default Header;